
#include <hmg.ch>

#define Msg( xValue, xTitle ) MsgBox( IF( HB_ISCHAR( xValue  ), xValue , HB_ValToExp( xValue ) ), ;
                                      IF( HB_ISNIL( xTitle ), '', ;
                                      IF( HB_ISCHAR( xTitle ), xTitle, HB_ValToExp( xTitle ) ) ) )
#define TTrim( n ) LTRIM( TRAN( n, "999,9999,999,999,999,999" ) )

PROCEDURE Main()

   FIELD GF_NAME, GF_DATA
   
   PRIVATE cHMG_RootDir := "C:\HMG",;           // Specify root folder of HMG
           MemoFName := "MmoLmTst",;
           ReadFName := "",;
           SaveFName := ""
           
   PRIVATE cReadText := ''
   
   PRIVATE aHFStruct := { { "GF_NAME", "C", 64, 0 },;     // Guest file name
                        { "GF_DATA", "M", 10, 0 } }    // Guest file data                  
   
   SET CENT ON    
   SET DATE GERM
   SET TOOLTIPSTYLE BALLOON

	DEFINE WINDOW frmMLTest ;
		AT 0,0 ;
		WIDTH 600 ;
		HEIGHT 450 ;
		TITLE 'Test MEMO limit' ;
      ON INIT Initilize() ;
		MAIN 
      
      ON KEY ESCAPE OF frmMLTest ACTION ThisWindow.Release
      
		DEFINE MAIN MENU
			DEFINE POPUP '&File'
            ITEM 'Read'   NAME mitReadFile ACTION ReadFile()
            ITEM 'Save'   NAME mitSaveAs   ACTION  SaveAs()
            ITEM 'Replace' NAME mitReplace  ACTION  ReplMemo()
            ITEM 'Result'  NAME mitRsult   ACTION  SayResult()
            SEPARATOR
            ITEM "E&xit"  ACTION ThisWindow.Release
			END POPUP
      
		END MENU // MAIN
            
      DEFINE STATUSBAR FONT 'Verdana' SIZE 8
          STATUSITEM ""
          STATUSITEM ""
          DATE WIDTH 80
          CLOCK WIDTH 90
      END STATUSBAR
         	
   END WINDOW
   
	CENTER   WINDOW frmMLTest
	ACTIVATE WINDOW frmMLTest

RETURN // MemLmtTest.Main()

*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-

PROCEDURE Initilize()

   DBCREATE( MemoFName, aHFStruct, "DBFFPT", .T., "Test" )

   ReadFile()
   
RETURN // Initilize()   
      
*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-

PROC ReadFile()

   ReadFName := Getfile( { {'Text (.txt) Files','*.txt'} },;     // acFilter
                    'Readf File' ,;                      // Title  
                    GetStartUpFolder(),;                // cDefaultPath 
                    .F.,;                               // lMultiSelect 
                    .T. )                               // lNoChangeCurrDir
                    
   cReadText :=  MEMOREAD( ReadFName )
   
   Msg( TTrim( LEN( cReadText ) ) + " bytes read from " + ReadFName + " file", "Read result" )
   
   frmMLTest.StatusBar.Item( 1 ) := ReadFName
   frmMLTest.StatusBar.Item( 2 ) := TTrim( LEN( cReadText ) )

RETU // ReadFile()
                    
*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-

PROC SaveAs() 
   SaveFName := PUTFILE()
   HB_MEMOWRIT( SaveFName, cReadText )
   Msg( TTrim( FILESIZE( ReadFName ) ) + " bytes saved as to " + SaveFName + " file", "Save result" )
RETU // SaveAs()

*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-

PROC ReplMemo()
   DBAPPEND()
   REPL GF_NAME WITH ReadFName,;
       GF_DATA WITH cReadText       
   Msg( TTrim( LEN( GF_DATA ) ) + " bytes replaced to MEMO field of " + MemoFName + " MEMO file", "replace result" )
       
RETU // ReplMemo()

*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-
                    
PROC SayResult()

   Msg( TTrim( LEN( cReadText ) ) + " bytes read from " + ReadFName + " file" + CRLF +;
       TTrim( FILESIZE( ReadFName ) ) + " bytes saved as to " + SaveFName + " file" + CRLF +;
       TTrim( LEN( GF_DATA ) ) + " bytes replaced to MEMO field of " + MemoFName + " MEMO file", "Results" )

RETU // SayResult()
*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-
